/*
 File: prt_xrefs_docs.h
 Date and Time: Fri Jan 30 18:55:21 2015 
*/
#ifndef __prt_xrefs_docs_h__
#define __prt_xrefs_docs_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "time.h"
#include "o2_externs.h"
#include "prt_sr_elements.h"
extern void PRT_RULE_S_FIRST_SET(std::ofstream& Ofile,NS_yacco2_terminals::rule_def* Rule_def);
extern void XLATE_SYMBOLS_FOR_cweave(const char* Sym_to_xlate,char* Xlated_sym);
extern int MPOST_CWEB_xlated_symbol(AST* Sym,char* Xlated_sym);
extern STATES_type LR1_STATES;
extern COMMON_LA_SETS_type COMMON_LA_SETS;

  
// monolithic grammar: no thread
extern yacco2::State S1_Cprt_xrefs_docs;
namespace NS_prt_xrefs_docs {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[9];
};
class Cprt_xrefs_docs: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rprt_xrefs_docs_ = 569//start_of_rule_list + 0
    ,rhs1_Rprt_xrefs_docs_ = 1
   ,R_Rrules_ = 570//start_of_rule_list + 2
    ,rhs1_Rrules_ = 2
    ,rhs2_Rrules_ = 3
   ,R_Rrule_ = 571//start_of_rule_list + 4
    ,rhs1_Rrule_ = 4
   ,R_Rrule_def_ = 572//start_of_rule_list + 6
    ,rhs1_Rrule_def_ = 5
   ,R_Rsubrules_ = 573//start_of_rule_list + 8
    ,rhs1_Rsubrules_ = 6
    ,rhs2_Rsubrules_ = 7
   ,R_Rsubrule_ = 574//start_of_rule_list + 10
    ,rhs1_Rsubrule_ = 8
   ,R_Rsubrule_def_ = 575//start_of_rule_list + 12
    ,rhs1_Rsubrule_def_ = 9
   ,R_Relements_ = 576//start_of_rule_list + 14
    ,rhs1_Relements_ = 10
    ,rhs2_Relements_ = 11
   ,R_Relement_ = 577//start_of_rule_list + 16
    ,rhs1_Relement_ = 12
    ,rhs2_Relement_ = 13
    ,rhs3_Relement_ = 14
    ,rhs4_Relement_ = 15
    ,rhs5_Relement_ = 16
    ,rhs6_Relement_ = 17
  };
  //no of la sets = 6
  //no of states = 23
  Cprt_xrefs_docs();
  ~Cprt_xrefs_docs();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[18];
  
    public:
	  char big_buf_[BIG_BUFFER_32K];		
          set<int> prt_sr_elems_filter_;
	  std::map <int , std::string> xlated_names_;
	  std::map <int , std::list<state_element*> > productions_derived_states_list_;
	  std::vector <state* > reducing_states_list_;
	  std::vector <int> no_subrules_per_rule_;
	  std::string gened_date_time_;
      std::string w_index_filename_;
      std::ofstream ow_index_file_;
      std::string grammar_filename_prefix_;
	  std::string fq_filename_noext_;
      int rule_no_;
      int subrule_no_;
      int elem_no_;
      int no_of_rules_;
      int no_of_subrules_;
      std::string rule_name_;
      std::string elem_name_;
	  rule_def* rule_def_;
	  T_subrule_def* subrule_def_;
   std::list<NS_yacco2_terminals::rule_def*> rules_for_fs_prt_;
   std::map<std::string, std::list<std::string> > xref_of_used_symbols_;
   void add_symbol_to_xref_map(std::string& Key,std::string& Ref);   
   void determine_closure_derived_states();
   void prt_states_follow_set();
   void prt_follow_set_local_yield(follow_element* Fe);
   void prt_follow_set_creators(follow_element* Fe);
   void prt_follow_set_transitions(follow_element* Fe);
   void prt_follow_set_merges(follow_element* Fe);
   void prt_state_s_follow_set_rules(state* Cur_state);
   void prt_common_follow_set_la();
   
 };
struct Rprt_xrefs_docs;
struct Rrules;
struct Rrule;
struct Rrule_def;
struct Rsubrules;
struct Rsubrule;
struct Rsubrule_def;
struct Relements;
struct Relement;
struct Rprt_xrefs_docs:public yacco2::CAbs_lr1_sym {
  Rprt_xrefs_docs(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rrules:public yacco2::CAbs_lr1_sym {
  Rrules(yacco2::Parser* P);
  public:
};

struct Rrule:public yacco2::CAbs_lr1_sym {
  Rrule(yacco2::Parser* P);
  public:
};

struct Rrule_def:public yacco2::CAbs_lr1_sym {
  Rrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rsubrules:public yacco2::CAbs_lr1_sym {
  Rsubrules(yacco2::Parser* P);
  public:
};

struct Rsubrule:public yacco2::CAbs_lr1_sym {
  Rsubrule(yacco2::Parser* P);
  public:
};

struct Rsubrule_def:public yacco2::CAbs_lr1_sym {
  Rsubrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Relements:public yacco2::CAbs_lr1_sym {
  Relements(yacco2::Parser* P);
  public:
};

struct Relement:public yacco2::CAbs_lr1_sym {
  Relement(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

} // end of namespace

#endif
